//
//formation class
//including all formation information and 
//present formation type.
//
import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;

public class Formation extends Observable{

	/*****************************/
	/*	static field	     */
	/****************************/
        static final int NORMAL_POS = 0;
        static final int NORMAL_POS_WIDE = 1;       
        static final int NORMAL_POS_NARROW = 2;

        static final int DEFENSIVE_POS = 3; 
        static final int DEFENSIVE_POS_WIDE = 4;
        static final int DEFENSIVE_POS_NARROW = 5;

	static final int OFFENSIVE_POS = 6;
        static final int OFFENSIVE_POS_WIDE = 7;
        static final int OFFENSIVE_POS_NARROW = 8;


        static final String[] FORMATION_NAME = 
             {"NORMAL","NORMAL_WIDE","NORMAL_NARROW","DEFENSIVE","DEFENSIVE_WIDE","DEFENSIVE_NARROW","OFFENSIVE","OFFENSIVE_WIDE","OFFENSIVE_NARROW"};

	static final String[] FORMATION_TYPE_NAME =         
		{"3-2-3-2", "3-2-3-2","3-2-3-2", 
		"3-3-3-1","3-3-3-1","3-3-3-1", 
		"2-2-3-3","2-2-3-3","2-2-3-3"};

        static final int MAN_MARK = -100;

	static final double[][] hyoujun = 
		//posX, posY, maxX, maxY, minX, minY 
		{{-47.0, 0.0, -30.5, 20.0, -55.0, -22.0},
		{29.3, 2.0, 55.0, 36.0, 20.5, -6.5}, 
		{24.0, -10.5, 55.0, 7.5, 12.5, -36.0}, 
		{-0.5, 19.5, 20.5, 36.0, -2.8, 10.0},
		{-0.5, -19.5, 20.0, -10.0, -2.0, -34.0},
		{-0.5, -0.5, 16.0, 13.0, -2.0, -13.0}, 
		{-17.0, 6.25, 4.89, 30.0, -30.0, 5.0}, 
		{-17.0, -6.25, 4.89, -5.0, -30.0, -30.0}, 
		{-18.5, 14.5, -12.0, 36.0, -60.0, 9.5}, 
		{-18.5, 0.0, -12.0, 10.5, -60.0, -10.5},
		{-18.5, -14.5, -12.0, -9.5, -60.0, -36.0}};

	static final int[] hyoujunUni = {1,2,3,4,5,6,7,8,9,10,11};

	static final double[][] hyojunMan = 
		{{-47.0, 0.0, -30.5, 20.0, -55.0, -22.0},
		{29.3, 2.0, 55.0, 27.0, 20.5, -6.5}, 
		{24.0, -10.5, 55.0, 7.5, 12.5, -21.0}, 
		{-0.5, 13.0, 20.0, 36.0, -2.8, -3.0},
		{-0.5, -13.0, 20.0, 3.0, -2.0, -34.0},
		{-100,0,0,0,0,0}, 
		{-17.0, 6.25, 4.89, 30.0, -30.0, 5.0},
		{-17.0, -6.25, 4.89, -5.0, -30.0, -30.0},
		{-18.5, 14.5, -12.0, 36.0, -60.0, 9.5},
		{-18.5, 0.0, -12.0, 10.5, -60.0, -10.5},
		{-18.5, -14.5, -12.0, -9.5, -60.0, -36.0}};

	static final double[][] shubi = 
                {{-47.0, 0.0, -30.5, 36.0, -55.0, -36.0},
                {29.3, 2.0, 55.0, 36.0, 20.5, -36.5},    
                {0.5, 0.5, 20.0, 15.0, -2.0, -15.0},
                {-0.5, 20.0, 20.0, 36.0, -2.8, -3.0},
                {-0.5, -20.0, 20.0, 3.0, -2.0, -34.0},
		{-15.0, 0.0, 1.0,13.0,-30.0,-13.0},
		{-17.0, 10.0, 4.89, 30.0, -30.0, 5.0},
		{-17.0, -10.0, 4.89, -5.0, -30.0, -30.0},
		{-30.5, 20.5, -12.0, 36.0, -60.0, 9.5},
		{-30.5, 0.0, -12.0, 10.5, -60.0, -10.5},
		{-30.5, -20.5, -12.0, -9.5, -60.0, -36.0}};

	//                            1,2,3,4,5,6,7,8,9,10,11
	static final int[] shubiUni = {1,2,2,4,5,3,7,8,9,10,11};

 	static final double[][] shubiMan = 
		{{-47.0, 0.0, -30.5, 36.0, -55.0, -22.0},
		{29.3, 2.0, 55.0, 27.0, 20.5, -6.5}, 
		{-100,0,0,0,0,0}, 
		{-0.5, 13.0, 20.0, 36.0, -2.8, -3.0},
		{-0.5, -13.0, 20.0, 3.0, -2.0, -34.0},
		{-15.0, 0.0, 1.0,13.0,-12.0,-13.0},
		{-17.0, 6.25, 4.89, 30.0, -30.0, 5.0}, 
		{-17.0, -6.25, 4.89, -5.0, -30.0, -30.0},
		{-18.5, 14.5, -12.0, 36.0, -60.0, 9.5},
		{-18.5, 0.0, -12.0, 10.5, -60.0, -10.5},
		{-18.5, -14.5, -12.0, -9.5, -60.0, -36.0}};

     static final double[][] kougeki = 
		{{-47.0, 0.0, -30.5, 20.0, -55.0, -22.0},
		{29.3, 20.0, 55.0, 36.0, 20.5, 0.0}, 
		{24.0,-10.5,55.0,0.0,12.5,-36.0},
		{31.0,5.0,55.0,20.0,17.0,-15.0},
		{-0.5, -13.0, 20.0, 3.0, -2.0, -34.0},
		{-5.0, 0.0, 10.0,13.0,-12.0,-13.0},
		{-17.0, 4.25, 4.89, 30.0, -30.0, -1.0},
		{-17.0, -4.25, 4.89, 1.0, -30.0, -30.0},
		{-18.5, 17.0, -12.0, 36.0, -60.0, -3.0},
		{-0.5, 13.0, 20.0, 36.0, -2.8, -3.0},
		{-18.5, -17.0, -12.0, 3.0, -60.0, -36.0}};

        //                              1,2,3,4,5,6,7,8,9,10,11
        static final int[] kougekiUni = {1,5,3,4,10,6,7,8,9,10,11};

     static final double[][] kougekiMan = 
		{{-47.0, 0.0, -30.5, 20.0, -55.0, -22.0},
		{29.3, 2.0, 55.0, 27.0, 20.5, -6.5}, 
		{24.0,-10.5,55.0,7.5,12.5,-21.0},
		{-0.5, 13.0, 20.0, 36.0, -2.8, -3.0},
		{-0.5, -13.0, 20.0, 3.0, -2.0, -34.0},
		{-15.0, 0.0, 1.0,13.0,-12.0,-13.0},
		{-17.0, 6.25, 4.89, 30.0, -30.0, 5.0},
		{-17.0, -6.25, 4.89, -5.0, -30.0, -30.0},
		{-18.5, 10.0, -12.0, 36.0, -60.0, -3.0},
		{-100,0,0,0,0,0},
		{-18.5, -10.0, -12.0, 3.0, -60.0, -36.0}};
 
       static final double[][] hyoujun_wide =
                {{-47.0, 0.0, -30.5, 20.0, -55.0, -22.0},
                {29.3, 2.0, 55.0, 36.0, 20.5, -6.5},
                {24.0, -15.5, 55.0, 7.5, 12.5, -36.0},
                {-0.5, 28.5, 20.5, 36.0, -2.8, 10.0},
                {-0.5, -28.5, 20.0, -10.0, -2.0, -34.0},
                {-0.5, -0.5, 16.0, 13.0, -2.0, -13.0},
                {-17.0, 12.25, 4.89, 30.0, -30.0, 5.0},
                {-17.0, -12.25, 4.89, -5.0, -30.0, -30.0},
                {-18.5, 25.5, -12.0, 36.0, -60.0, 9.5}, 
                {-18.5, 0.0, -12.0, 10.5, -60.0, -10.5},
                {-18.5, -25.5, -12.0, -9.5, -60.0, -36.0}};

     static final double[][] kougeki_wide =
                {{-47.0, 0.0, -30.5, 20.0, -55.0, -22.0},
                {29.3, 20.0, 55.0, 36.0, 20.5, 0.0},
                {24.0,-20.5,55.0,0.0,12.5,-36.0},
                {31.0,0.0,55.0,20.0,17.0,-15.0},
                {-0.5, -18.0, 20.0, 3.0, -2.0, -34.0},
                {-5.0, 0.0, 10.0,13.0,-12.0,-13.0},
                {-17.0, 4.25, 0, 30.0, -30.0, 5.0},
                {-17.0, -4.25, 0, -5.0, -30.0, -30.0},
                {-18.5, 18.0, -12.0, 36.0, -60.0, -3.0},
                {-0.5, 25.0, 20.0, 36.0, -2.8, -3.0},   
                {-18.5, -23.0, -12.0, 3.0, -60.0, -36.0}}; 

        static final double[][] shubi_wide =   
                {{-47.0, 0.0, -30.5, 20.0, -55.0, -22.0},
                {29.3, 2.0, 55.0, 36.0, 20.5, -36.0},
                {0.5, 0.5, 20.0, 15.0, -2.0, -15.0},
                {-0.5, 25.0, 20.0, 36.0, -2.8, -3.0},
                {-0.5, -25.0, 20.0, 3.0, -2.0, -34.0},
                {-15.0, 0.0, 1.0,13.0,-30.0,-13.0},
                {-17.0, 12.0, 4.89, 30.0, -30.0, 5.0},
                {-17.0, -12.0, 4.89, -5.0, -30.0, -30.0},
                {-30.5, 25.5, -12.0, 36.0, -60.0, 9.5}, 
                {-30.5, 0.0, -12.0, 10.5, -60.0, -10.5},
                {-30.5, -25.5, -12.0, -9.5, -60.0, -36.0}};

        static final double[][] hyoujun_narrow =
                //posX, posY, maxX, maxY, minX, minY
                {{-47.0, 0.0, -30.5, 20.0, -55.0, -22.0},
                {29.3, 2.0, 55.0, 36.0, 20.5, -36.0},
                {24.0, -7.5, 55.0, 7.5, 12.5, -21.0},
                {-0.5, 15.5, 20.5, 36.0, -2.8, 10.0},
                {-0.5, -15.5, 20.0, -10.0, -2.0, -34.0},
                {-0.5, -0.5, 16.0, 13.0, -2.0, -13.0},
                {-17.0, 4.25, 2.89, 30.0, -30.0, 0.0}, 
                {-17.0, -4.25, 2.89, 0.0, -30.0, -30.0}, 
                {-18.5, 11.0, -12.0, 36.0, -60.0, 9.5}, 
                {-18.5, 0.0, -12.0, 10.5, -60.0, -10.5},
                {-18.5, -11.0, -12.0, -9.5, -60.0, -36.0}};

	static final double[][] kougeki_narrow =
                {{-47.0, 0.0, -30.5, 20.0, -55.0, -22.0},
                {29.3, 13.0, 55.0, 36.0, 20.5, 0.0},
                {24.0,-10.5,55.0,0.0,12.5,-36.0},
                {31.0,3.0,55.0,20.0,17.0,-15.0},
                {-0.5, -13.0, 20.0, 3.0, -2.0, -34.0},  
                {-5.0, 0.0, 10.0,13.0,-12.0,-13.0},   
                {-17.0, 4.25, 4.89, 30.0, -30.0, -1.0}, 
                {-17.0, -4.25, 4.89, -1.0, -30.0, -30.0}, 
                {-18.5, 12.0, -12.0, 36.0, -60.0, -3.0},
                {-0.5, 13.0, 20.0, 36.0, -2.8, -3.0},   
                {-18.5, -12.0, -12.0, 3.0, -60.0, -36.0}}; 

        static final double[][] shubi_narrow =

                {{-47.0, 0.0, -30.5, 20.0, -55.0, -22.0},
                {29.3, 2.0, 55.0, 36.0, 20.5, -36.0},    
                {0.5, 0.0, 20.0, 15.0, -2.0, -15.0},
                {-0.5, 15.0, 20.0, 36.0, -2.8, -3.0},
                {-0.5, -15.0, 20.0, 3.0, -2.0, -34.0},
                {-15.0, 0.0, 1.0,13.0,-30.0,-13.0},   
                {-17.0, 6.0, 4.89, 30.0, -30.0, 5.0}, 
                {-17.0, -6.0, 4.89, -5.0, -30.0, -30.0}, 
                {-30.5, 17.5, -12.0, 36.0, -60.0, 9.5}, 
                {-30.5, 0.0, -12.0, 10.5, -60.0, -10.5},
                {-30.5, -17.5, -12.0, -9.5, -60.0, -36.0}};

/*	
    static final double[][][] positions = {initPosition, hyojunMan, shubi, shubiMan, kougeki, kougekiMan, hyoujun_wide, shubi_wide, kougeki_wide};
*/
    static final double[][][] positions = {hyoujun, hyoujun_wide, hyoujun_narrow, shubi, shubi_wide, shubi_narrow, kougeki, kougeki_wide, kougeki_narrow};
  
    static final int[][] kickLocation = {hyoujunUni, shubiUni, kougekiUni};


	/******************************************/
	/*              field                     */
	/******************************************/	

	int presentFormation;


	/****************************************/
	/*         constructor                  */
	/****************************************/
	Formation(){

		this(NORMAL_POS);

	}

        Formation(int type){

                presentFormation = type;

		//setFormationType(type);
        }

	/****************************************/
	/*             method                   */ 
	/****************************************/
	public void setFormationType(int type){

		presentFormation = type;	

		changes();	

	} 
	
	public int getFormationType(){
		
		return presentFormation;			
	}
	
	public String getFormationName(){

		return FORMATION_NAME[presentFormation];	
	
	}

	public String getFormationTypeName(){

		return FORMATION_TYPE_NAME[presentFormation];	

	}

	public double[] getFormationLocation(int unum){

		return positions[presentFormation][unum];
		
	}

	//override interface observable
	public void changes(){
		
		setChanged();
		notifyObservers();

	}
}

