/***********************************/
/*				   */	
/*          Memory.java		   */	
/*	   			   */	
/*				   */	
/***********************************/

class Memory  
{ 
	private	JudgeInfo jinfo		= new JudgeInfo();
	volatile private VisualInfo	m_info;	
	final static int SIMULATOR_STEP = 100; 

	public Memory() 
	{ 
	} 

	public void store(VisualInfo info) 
	{ 
		m_info = info; 
	} 

	public void jstore(String str)
	{
		jinfo.parseJudge(str);
	}

	public ObjectInfo getObject(String name)  
	{ 
		if( m_info == null ) 
			waitForNewInfo(); 
		for(int c = 0 ; c < m_info.m_objects.size() ; c ++) 
		{ 
			ObjectInfo object = 
			(ObjectInfo)m_info.m_objects.elementAt(c); 
			if(object.m_type.compareTo(name) == 0) 
				return object; 
		}						  
		return null; 
	} 

	public void waitForNewInfo()  
	{ 
		m_info = null; 
		while(m_info == null) 
		{ 
			try 
			{ 
				Thread.sleep(SIMULATOR_STEP); 
			} 
			catch(Exception e) {} 
		} 
	} 
} 
 



