/**********************************/
/* 				  */
/* 	   VisualInfo.java 	  */
/* 	   $B;k3P>pJs$N@0M}(B 	  */
/*  				  */
/**********************************/

import java.util.*; 
import java.io.*;

class VisualInfo  
{ 
	Vector	m_objects; 
	private StringTokenizer	m_tokenizer; 
 
	public VisualInfo(String info) 
	{ 
	  //	      System.out.println(info);
		info.trim(); 
		m_tokenizer = new StringTokenizer(info,"() ", true); 
		m_objects = new Vector(41); 
	} 
 
        public void parse() 
	{ 
		String token = null; 
		ObjectInfo	objInfo; 

		try 
		{ 
			m_tokenizer.nextToken();	 
			if( m_tokenizer.nextToken().compareTo("see") != 0 )	 
				return; 
			m_tokenizer.nextToken();	 
			MyBody.time = Integer.parseInt( m_tokenizer.nextToken() ); 
			m_tokenizer.nextToken();	 
 
			token = m_tokenizer.nextToken(); 
 
			while(token.compareTo("(") == 0) 
			{ 
				objInfo = createNewObject(); 
				m_objects.addElement(objInfo); 
				 
				token = m_tokenizer.nextToken(); 
				if( token.compareTo(")") == 0 ) 
				{ 
					token = m_tokenizer.nextToken(); 
					if(token.compareTo(" ") == 0) 
						token = m_tokenizer.nextToken(); 
					continue; 
				} 
 
				token = m_tokenizer.nextToken(); 
				objInfo.m_distance = Float.valueOf(token).floatValue(); 
				token = m_tokenizer.nextToken(); 
				if( token.compareTo(")") == 0 ) 
				{ 
					token = m_tokenizer.nextToken(); 
					if(token.compareTo(" ") == 0) 
						token = m_tokenizer.nextToken(); 
					continue; 
				} 
 
				objInfo.m_direction = Float.valueOf
					(m_tokenizer.nextToken()).floatValue(); 
				token = m_tokenizer.nextToken(); 
				if( token.compareTo(")") == 0 ) 
				{ 
					token = m_tokenizer.nextToken(); 
					if(token.compareTo(" ") == 0) 
						token = m_tokenizer.nextToken(); 
					continue; 
				} 
 
				objInfo.m_distChange = Float.valueOf
					(m_tokenizer.nextToken()).floatValue(); 
				token = m_tokenizer.nextToken(); 
				if( token.compareTo(")") == 0 ) 
				{ 
					token = m_tokenizer.nextToken(); 
					if(token.compareTo(" ") == 0) 
						token = m_tokenizer.nextToken(); 
					continue; 
				} 
 
				objInfo.m_distChange = Float.valueOf
					(m_tokenizer.nextToken()).floatValue(); 
				token = m_tokenizer.nextToken(); 
				if( token.compareTo(")") == 0 ) 
				{ 
					token = m_tokenizer.nextToken(); 
					if(token.compareTo(" ") == 0) 
						token = m_tokenizer.nextToken(); 
					continue; 
				} 
 
				objInfo.m_dirChange = Float.valueOf
					(m_tokenizer.nextToken()).floatValue(); 
				token = m_tokenizer.nextToken(); 
				token = m_tokenizer.nextToken(); 
				if(token.compareTo(" ") == 0) 
					token = m_tokenizer.nextToken(); 
			} 
		} 
		catch(Exception e) 
		{ 
		  	System.out.println("Error parsing see information"); 
		  	System.out.println(token); 
			while( m_tokenizer.hasMoreTokens() ) 
				System.out.print(m_tokenizer.nextToken()); 
		} 
	} 

	private ObjectInfo createNewObject() 
	{ 
		String			token; 
		ObjectInfo	objInfo = null; 

		m_tokenizer.nextToken(); 
		token = m_tokenizer.nextToken(); 

		/********************************/
		/*          Player              */
		/********************************/
		if(token.compareTo("player") == 0) 
		{ 
			String team = new String(); 
			int uniformNumber = 0; 
			token = m_tokenizer.nextToken();
			if(token.compareTo(" ") == 0) 
			{ 
				team = m_tokenizer.nextToken();	
				token = m_tokenizer.nextToken();
				if(token.compareTo(" ") == 0) 
					uniformNumber = Integer.parseInt
						(m_tokenizer.nextToken());
				} 
				objInfo = new PlayerInfo(team,uniformNumber); 
			} 
		        /********************************/
                	/*            Goal              */
		        /********************************/
			else if(token.compareTo("goal") == 0) 
			{ 
				token = m_tokenizer.nextToken();
				if(token.compareTo(" ") == 0) 
					token = m_tokenizer.nextToken();
				objInfo = new GoalInfo(token.charAt(0)); 
			} 
		        /********************************/
                	/*            Boal              */
		        /********************************/
			else if(token.compareTo("ball") == 0) 
			{ 
				objInfo = new BallInfo(); 
			} 
		        /********************************/
                	/*            Flag              */
		        /********************************/
			else if(token.compareTo("flag") == 0) 
			{ 
				char type = ' '; 
				char posHoriz, posVert; 
				token = m_tokenizer.nextToken();
				token = m_tokenizer.nextToken();
				if( token.compareTo("p") == 0 ) 
				{ 
					type = token.charAt(0); 
					token = m_tokenizer.nextToken();
					token = m_tokenizer.nextToken();
				} 
				/*******************************/
				/*******************************/
				/**                           **/
				/**       After Version 4     **/
				/**                           **/
				/*******************************/
				/*******************************/
				else if( token.compareTo("g") == 0 ) 
				{ 
					type = token.charAt(0); 
					token = m_tokenizer.nextToken();
					token = m_tokenizer.nextToken();
				} 
				else if( token.compareTo("t") == 0 ) 
				{ 
					type = token.charAt(0); 
					token = m_tokenizer.nextToken();
					token = m_tokenizer.nextToken();
				} 
				else if( token.compareTo("b") == 0 ) 
				{ 
					type = token.charAt(0); 
					token = m_tokenizer.nextToken();
					token = m_tokenizer.nextToken();
				} 
				else if( token.compareTo("l") == 0 ) 
				{ 
					type = token.charAt(0); 
					token = m_tokenizer.nextToken();
					token = m_tokenizer.nextToken();
				} 
				else if( token.compareTo("r") == 0 ) 
				{ 
					type = token.charAt(0); 
					token = m_tokenizer.nextToken();
					token = m_tokenizer.nextToken();
				} 

				posHoriz = token.charAt(0); 
				token = m_tokenizer.nextToken();
				token = m_tokenizer.nextToken();
				posVert = token.charAt(0); 
				objInfo = new FlagInfo(type, posHoriz, posVert); 
			} 
		        /********************************/
                	/*            Line              */
		        /********************************/
			else if(token.compareTo("line") == 0) 
			{ 
				token = m_tokenizer.nextToken();
				token = m_tokenizer.nextToken();
				objInfo = new LineInfo(token.charAt(0)); 
			} 
			else if(token.compareTo("Player") == 0) 
			{ 
				objInfo = new PlayerInfo(); 
			} 
			else if(token.compareTo("Goal") == 0) 
			{ 
				objInfo = new GoalInfo(); 
			} 
			else if(token.compareTo("Ball") == 0) 
			{ 
				objInfo = new BallInfo(); 
			} 
			else if(token.compareTo("Flag") == 0) 
			{ 
				objInfo = new FlagInfo(); 
			} 
			else if(token.compareTo("Line") == 0) 
			{ 
				objInfo = new LineInfo(); 
			} 
 
			if(token.compareTo(")") != 0) 
				token = m_tokenizer.nextToken();	 
 
			return objInfo; 
	} 
} 
 







