/***********************************/
/*				   */	
/*          Memory.java		   */	
/*	   			   */	
/*				   */	
/***********************************/
import java.util.*;
class Memory  
{ 
	private	JudgeInfo jinfo		= new JudgeInfo();
	volatile private VisualInfo	m_info;	
	final static int SIMULATOR_STEP = 100; 



	public Memory() 
	{ 



	} 

	public void store(VisualInfo info) 
	{ 
		m_info = info; 
	} 

	public void jstore(String str)
	{
		jinfo.parseJudge(str);
	}

	//add 990725 by S.F
	public boolean canFixMyPos(){

		boolean haveLineInfo = false;
		boolean haveFlagInfo = false;

		Object o;

		for(Enumeration e = m_info.m_objects.elements(); e.hasMoreElements();){

			o = e.nextElement();

			if(o instanceof LineInfo){
				
				ObjectInfo l = (ObjectInfo)o;

				if(l.m_type.compareTo("line") != 0 ){			
					haveLineInfo = true;
				}

			}else if(o instanceof FlagInfo){
				
				ObjectInfo f = (ObjectInfo)o;
				
				if(f.m_type.compareTo("flag") != 0){
					haveFlagInfo = true;
				}
			}

		}

		return (haveFlagInfo && haveLineInfo);
	}

	public ObjectInfo getObject(String name)  
	{ 
		if( m_info == null ) 
			waitForNewInfo(); 
		for(int c = 0 ; c < m_info.m_objects.size() ; c ++) 
		{ 
			ObjectInfo object = 
			(ObjectInfo)m_info.m_objects.elementAt(c); 

			//System.out.println(object.m_type);

			if(object.m_type.compareTo(name) == 0) 
				return object; 
		}						  
		return null; 
	} 

	/*****************************************/
	/*      add 990726 by S.F                */
	/*****************************************/

	public ObjectInfo getFlagObject(){

                Object o;
        	DPoint dp;
	
                for(Enumeration e = m_info.m_objects.elements(); e.hasMoreElements();){
                        o = e.nextElement();
                
                        if(o instanceof FlagInfo){  
                         
                                ObjectInfo f = (ObjectInfo)o; 
                                
                                if(f.m_type.compareTo("flag") != 0){
					return f;

				}
                        
                        }

                }


		return null;

	}
	public void waitForNewInfo()  
	{ 
		m_info = null; 
		while(m_info == null) 
		{ 
			try 
			{ 
				Thread.sleep(SIMULATOR_STEP); 
			} 
			catch(Exception e) {} 
		} 
	} 
} 
 



